local MHiCS_old_on_join_request_reply = ClientNetworkSession.on_join_request_reply

function ClientNetworkSession:on_join_request_reply(
			reply, my_peer_id, my_character, level_index,
			difficulty_index, one_down, state_index, server_character, user_id,
			mission, job_id_index, job_stage, alternative_job_stage,
			interupt_job_stage_level_index, xuid, ...
		)
		
	if reply == 1 and managers.crime_spree:is_active() and MHiCS.settings.enabled and string.find(xuid, "|") then
		-- Host has BeardLib and therefore potentially custom heists
		local job_id, level_id, difficulty, level_name = unpack(string.split(xuid, "|"))
		level_index = tweak_data.levels:get_index_from_level_id(level_id)
		if not level_index then
			-- Theoretically BeardLib could attempt a download, but this is complicated enough
			-- BeardLib devs, hit me up with a fix and I will include it
			level_index = tweak_data.levels:get_index_from_level_id(MHiCS._strings.dummy)
			state_index = 1
		end
	end
	-- If host does not have BeardLib, they should not be able to host a custom heist either (fingers crossed)
	
	return MHiCS_old_on_join_request_reply(self, 
			reply, my_peer_id, my_character, level_index,
			difficulty_index, one_down, state_index, server_character, user_id,
			mission, job_id_index, job_stage, alternative_job_stage,
			interupt_job_stage_level_index, xuid, ...
		)
end

local MHiCS_old_ok_to_load_level = ClientNetworkSession.ok_to_load_level

function ClientNetworkSession:ok_to_load_level(...)
	if Global.game_settings.level_id == MHiCS._strings.dummy then
		DelayedCalls:Add("MHiCS_SendMessage_sitout", 1, function()
			MHiCS:SendMessage(1, MHiCS._network.sitout, nil)
			local mod_name = "[" .. managers.localization:text("MHiCS_main_menu_title") .. "]"
			managers.chat:_receive_message(1, mod_name, managers.localization:text("MHiCS_host_plays_custom"), Color.yellow)
			managers.chat:_receive_message(1, mod_name, managers.localization:text("MHiCS_host_plays_custom2"), Color.yellow)
		end)
		MHiCS.me_sit_out = true
		return
	end
	MHiCS.me_sit_out = false
	return MHiCS_old_ok_to_load_level(self, ...)
end