local MHiCS_old_LootManager__setup = LootManager._setup

function LootManager:_setup()
	-- crime_spree manager does not exist at this point, we need to check for active crime spree somehow else
	local cs = Global.job_manager and Global.job_manager.current_job and Global.job_manager.current_job.job_id == "crime_spree"
	if not cs then
		return MHiCS_old_LootManager__setup(self)
	end
	
	-- FourStores Fix
	Global.loot_manager = nil
	MHiCS_old_LootManager__setup(self)
	
	-- Again crime_spree manager does not exist at this point
	local level_id =  Global.job_manager.current_job.level_id
	if string.begins(level_id, "escape") then
		-- Give players something to do
		for i=1,4 do
			table.insert(self._global.secured, {
				carry_id = "meth",
				multiplier = 1,
				peer_id = 1
			})
		end
		-- Unfortunately this does not work for some reason, would be cool
		-- self:set_mandatory_bags_data("none", 4)
		MHiCS_old_LootManager__setup(self)
	elseif level_id == "framing_frame_2" then
		-- FF Day 2 fix
		for i=1,4 do
			table.insert(self._global.secured, {
				carry_id = "painting",
				multiplier = 1,
				peer_id = 1
			})
		end
		MHiCS_old_LootManager__setup(self)
	end
end