local MHiCS_old_crime_spree_start_game = MenuCallbackHandler.crime_spree_start_game

function MenuCallbackHandler:crime_spree_start_game()
	if not MHiCS.settings.enabled or not MHiCS.settings.more then
		return MHiCS_old_crime_spree_start_game(self)
	end
	
	local mission_id = managers.crime_spree:current_mission()
	if not mission_id then
		return MHiCS_old_crime_spree_start_game(self)
	end
	
	local missions_gui = managers.menu_component:crime_spree_missions_gui()
	local idx = missions_gui:get_selected_index()
	
	local found = false
	for _, mission_data in ipairs(tweak_data.crime_spree.missions[idx]) do
		found = found or mission_data.id == mission_id
	end
	if found then
		return MHiCS_old_crime_spree_start_game(self)
	end
	local dialog_data = {
		title = managers.localization:text("dialog_warning_title"),
		text = managers.localization:text("MHiCS_not_all_know_warning")
	}
	local cont_button = {
		text = managers.localization:text("MHiCS_not_all_know_option_start")
	}
	local reroll_button = {
		text = managers.localization:text("MHiCS_not_all_know_option_reroll")
	}
	local close_button = {
		text = managers.localization:text("MHiCS_not_all_know_option_abort")
	}
	dialog_data.focus_button = 3
	dialog_data.button_list = {
		cont_button,
		reroll_button,
		close_button
	}
	cont_button.callback_func = function(this, item)
		MHiCS_old_crime_spree_start_game(self)
	end
	reroll_button.callback_func = function(this, item)
		MHiCS:reroll_slot(idx)
		MenuCallbackHandler:save_progress()
	end
	managers.system_menu:show(dialog_data)
end