local MHiCS_old_get_allow_mods_filter = NetworkMatchMakingEPIC.get_allow_mods_filter
function NetworkMatchMakingEPIC:get_allow_mods_filter()
	if (Global.game_settings.gamemode_filter == GamemodeCrimeSpree.id or MHiCS.crimespree_lobby_everywhere) and MHiCS.settings.enabled then
		if MHiCS.settings.only_lobbies then
			return true, 2, "equal"
		end
		return true, 1, "equalto_or_greater_than"
	end
	return MHiCS_old_get_allow_mods_filter(self)
end

local MHiCS_old_get_allow_mods_setting = NetworkMatchMakingEPIC.get_allow_mods_setting
function NetworkMatchMakingEPIC:get_allow_mods_setting()
	if managers.crime_spree:is_active() and MHiCS.settings.enabled and MHiCS.settings.more then
		return 2
	end	
	return MHiCS_old_get_allow_mods_setting(self)
end

local MHiCS_old_is_server_ok = NetworkMatchMakingEPIC.is_server_ok
function NetworkMatchMakingEPIC:is_server_ok(friends_only, room, attributes_list, is_invite)
	if not MHiCS.settings.enabled then
		MHiCS_old_is_server_ok(self, friends_only, room, attributes_list, is_invite)
	end

	local lobby = EpicMM:lobby(room.room_id)
	if lobby then
		local attributes_numbers = attributes_list.numbers
		
		local crime_spree_mission = lobby:key_value("crime_spree_mission")
		if crime_spree_mission and crime_spree_mission~="" then
			local level_id, job_id = self:_split_attribute_number(attributes_numbers[1], 1000)
			local level_name = managers.crime_spree:get_mission(attributes_list.crime_spree_mission).level.level_id
			level_id = tweak_data.levels:get_index_from_level_id(level_name)
			attributes_numbers[1] = level_id + 1000 * job_id
		end
	
		if lobby:key_value("allow_mods") == tostring(2) then
			attributes_numbers[7] = attributes_numbers[7] - 101
		end
	end
	
	return MHiCS_old_is_server_ok(self, friends_only, room, attributes_list, is_invite)
end

local MHiCS_old_set_attributes = NetworkMatchMakingEPIC.set_attributes
function NetworkMatchMakingEPIC:set_attributes(settings)
	if not managers.crime_spree:is_active() or not MHiCS.settings.enabled or not MHiCS.settings.more then
		return MHiCS_old_set_attributes(self, settings)
	end
	-- set minimum level to at least 101 or 101 over the real min level
	local old_min_level = settings.numbers[7]
	settings.numbers[7] = old_min_level and old_min_level + 101 or 101
	local ret = MHiCS_old_set_attributes(self, settings)
	settings.numbers[7] = old_min_level
	return ret
end